import { _ as _define_property } from "@swc/helpers/_/_define_property";
import { Text } from '@codemirror/state';
import { ViewPlugin } from '@codemirror/view';
export class FinalNewLinePlugin {
    ensureFinalNewLine(newLine = false) {
        const endLine = this.view.state.doc.line(this.view.state.doc.lines);
        if (endLine.length) {
            const hasSelection = this.view.state.selection.ranges.some((range)=>range.from !== range.to);
            this.view.dispatch({
                changes: {
                    from: endLine.to,
                    insert: Text.of([
                        '',
                        ''
                    ])
                },
                selection: newLine && !hasSelection ? {
                    anchor: endLine.to + 1,
                    head: endLine.to + 1
                } : undefined
            });
        }
    }
    update(update) {
        if (update.focusChanged) {
            setTimeout(()=>{
                this.ensureFinalNewLine();
            }, 0);
        }
    }
    constructor(view){
        _define_property(this, "view", void 0);
        this.view = view;
        setTimeout(()=>{
            this.ensureFinalNewLine(true);
        }, 0);
    }
}
const plugin = ViewPlugin.fromClass(FinalNewLinePlugin);
export default plugin;
